#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "contrast.h"
#include "edges.h"

int Num_Orientations = 4;
double Sigma_c = 1.3;
double Sigma_s = 1.3;
int O_Contrast = 1;
int I_Contrast = 0;
int O_Target = 180;

main(int argc, char *argv[])
{
  unsigned char *in_image, *char_con_map;
  double **gaus_c, **gaus_s;
  double *con_map, *norm_con_map;
  int level_size, max;
  double max2;
  int i, j, k, m, n;
  int Min_Radius = 3;
  int Max_Radius = 7;
  char imname[30], temp_name[30];
  FILE *data_file;
  int orien;

  for(i=1; i<argc; i++)
  {
    max2=0;
    max = read_pgm(argv[i], &in_image, &level_size, &level_size);

    con_map = (double *) calloc(level_size*level_size, sizeof(double));
    norm_con_map = (double *) malloc(level_size*level_size*sizeof(double));
    char_con_map = (unsigned char *) malloc(level_size*level_size);
  
    for (k=1; k<level_size-1; k++)
      for (j=1; j<level_size-1; j++)
      {
	for (m=-1; m<=1; m++)
	  for (n=-1; n<=1; n++)
	    con_map[k*level_size+j]+=in_image[(k+m)*level_size + (j+n)];
	con_map[k*level_size + j] = (float)(con_map[k*level_size + j])/9.0;
  	if(con_map[k*level_size+j]>max2) max2=con_map[k*level_size+j];
      }

    printf("max2 = %g\n", max2);
    
    /* write out double image data  
      data_file = fopen("norm_dbl_data", "w");
      for (k=0; k<level_size; k++)
      {
      	for (j=0; j<level_size; j++)
       	  fprintf(data_file, "%d ", (int)norm_con_map[k*level_size+j]);
        fprintf(data_file, "\n");
      }
    */

    /* convert to unsigned char */
    d_to_c(con_map, char_con_map, level_size*level_size);

    /* make image name */
    strncpy(temp_name, argv[i], strlen(argv[i])-3);
    sprintf(imname, "%ss.pgm", temp_name);

    /* write as pgm image */
    write_pgm(imname, char_con_map, level_size, level_size, 255);

    free(con_map);
    free(norm_con_map);
    free(char_con_map);

  }
}

void norm_dbl(double *from, double *to, int size, double max)
{
  int i;
  double factor=255.0/max;
  FILE *fa, *fb;

  for(i=0; i<size; i++)
  {
    to[i] = from[i]>0.0 ? from[i]*factor : 0.0;
  }

}

void d_to_c(double *from, unsigned char *to, int size)
{
  int i;
  for (i=0; i<size; i++)
    to[i] = from[i]>0.0 ? (unsigned char)from[i] :0;
}

